diff -arcN emacs-18.55/src/regex.c nemacs-3.3.2/src/regex.c
*** emacs-18.55/src/regex.c	Fri Aug 19 03:24:38 1988
--- nemacs-3.3.2/src/regex.c	Wed Jun  6 03:18:22 1990
***************
*** 1,3 ****
--- 1,10 ----
+ /* 88.1.5   modified for Nemacs Ver.2.0 by K.Handa */
+ /* 89.10.19 modified for Nemacs Ver.3.2 by K.Handa */
+ /* 90.1.25  modified for Nemacs Ver.3.3.1 by K.Handa
+ 		correct re_search when kanji-flag is nil */
+ /* 90.4.10  modified for Nemacs Ver.3.3.2 by enami@ptgd.sony.co.jp
+ 	bug fix of re_search with [...] structure */
+ 
  /* Extended regular expression matching and search.
     Copyright (C) 1985 Free Software Foundation, Inc.
  
***************
*** 118,123 ****
--- 125,133 ----
  #include "lisp.h"
  #include "buffer.h"
  #include "syntax.h"
+ #ifdef NEMACS  /* 89.9.14  by K.Handa */
+ #include "kanji.h"
+ #endif
  
  #else  /* not emacs */
  
***************
*** 225,230 ****
--- 235,251 ----
    c = * (unsigned char *) p++; \
    if (translate) c = translate[c]; }
  
+ #ifdef NEMACS  /* 89.12.4 by K.Handa */
+ #define PATFETCH2(c1,c2) \
+  {PATFETCH (c2); \
+   if (JCODE(c2)) { \
+     c1 = (c2 &= 0x7f); \
+     PATFETCH (c2); \
+     c2 &= 0x7f; \
+   } else \
+     c1 = 0; }
+ #endif  /* NEMACS */
+ 
  #define PATFETCH_RAW(c) \
   {if (p == pend) goto end_of_pattern; \
    c = * (unsigned char *) p++; }
***************
*** 311,316 ****
--- 332,342 ----
  
    int regnum = 1;
  
+ #ifdef NEMACS  /* 89.11.14  by K.Handa */
+   int bf_kanji = !NULL(bf_cur->kanji_flag);
+   int jcode_set;
+ #endif
+ 
    bufp->fastmap_accurate = 0;
  
  #ifndef emacs
***************
*** 469,474 ****
--- 495,519 ----
  	  break;
  
  	case '[':
+ #ifdef NEMACS  /* 89.11.14  by K.Handa */
+ 	  {
+ 	    char *pp = p;
+ 	    jcode_set = 0;
+ 	    if (bf_kanji)
+ 	      while (pp < pend && *pp != ']') {
+ 		if (JCODE((unsigned char)*pp++)) {
+ 		  jcode_set = 1;
+ 		  break;
+ 		}
+ 	      }
+ 	  }
+ 	  if (jcode_set) {	/* If any Japanese code is in the set,
+ 				   we need a large map. */
+ 	    while (b - bufp->buffer
+ 		   > bufp->allocated - 4 - ((1 << 14) / BYTEWIDTH))
+ 	      EXTEND_BUFFER;
+ 	  } else
+ #endif  /* NEMACS */
  	  while (b - bufp->buffer
  		 > bufp->allocated - 3 - (1 << BYTEWIDTH) / BYTEWIDTH)
  	    /* Note that EXTEND_BUFFER clobbers c */
***************
*** 481,486 ****
--- 526,584 ----
  	    PATPUSH (charset);
  	  p1 = p;
  
+ #ifdef NEMACS  /* 89.11.14  by K.Handa */
+ 	  if (jcode_set) {
+ 	    int maxcc = 0, c11, c12, c21, c22;
+ 	    PATPUSH (0);	/* If (!jcode_set) this value is set smaller
+ 				   than 32 [= (1<<BYTEWIDTH)/BYTEWIDTH], and
+ 				   it's a real length of the map.
+ 				   But if (jcode_set) this value is set greater
+ 				   than 33 [= 0x21],
+ 				   and it represents (length_of_map/16). */
+ 	    bzero (b, (1 << 14) / BYTEWIDTH); /* clear the whole map */
+ 	    while (1) {
+ 	      int c11 = 0, c21 = 0;
+ 	      PATFETCH2 (c11,c12);
+ 	      if (c11 > maxcc) maxcc = c11;
+ 	      /* patch by enami@ptgd.sony.co.jp 90/4/10 */
+ #if 0
+ 	      /* orignal code was */
+ 	      if (c12 == ']' && p != p1 + 1) break;
+ #else
+ 	      if (c12 == ']' && !c11 && p != p1 + 1) break;
+ #endif
+ 	      if (*p == '-' && p[1] != ']') {
+ 		unsigned char *bb = (unsigned char *)&b[c11 * 16];
+ 		int ctemp;
+ 
+ 		PATFETCH (c22);	/* discard '-' */
+ 		PATFETCH2 (c21,c22);
+ 		if (c21 > maxcc) maxcc = c21;
+ 		if (c11 < c21) {
+ 		  while (c12 < 0x7f) bb[c12 / 8] |= 1 << (c12 % 8), c12++;
+ 		  c12 = 0x21;
+ 		  bb += 16;
+ 		  c11++;
+ 		}
+ 		while (c11 < c21) {
+ 		  bb[0] = bb[1] = 0; bb[2] = 0xfe; /* to start from 0x21 */
+ 		  for (ctemp = 3; ctemp < 15; ctemp++) bb[ctemp] = 255;
+ 		  bb[15] = 0x7f; /* to end at 0x7e */
+ 		  bb += 16;
+ 		  c11++;
+ 		}
+ 		if (c11 == c21)
+ 		  while (c12 <= c22) {
+ 		    bb[c12 / 8] |= 1 << (c12 % 8);
+ 		    c12++;
+ 		  }
+ 	      } else {
+ 		b[c11 * 16 + c12 / 8] |= 1 << (c12 % 8);
+ 	      }
+ 	    }
+ 	    b[-1] = ++maxcc;
+ 	  } else {
+ #endif  /* NEMACS */
  	  PATPUSH ((1 << BYTEWIDTH) / BYTEWIDTH);
  	  /* Clear the whole map */
  	  bzero (b, (1 << BYTEWIDTH) / BYTEWIDTH);
***************
*** 503,508 ****
--- 601,614 ----
  	    }
  	  /* Discard any bitmap bytes that are all 0 at the end of the map.
  	     Decrement the map-length byte too. */
+ #ifdef NEMACS  /* 89.11.14  by K.Handa */
+ 	  }
+ 	  if (b[-1] > 32) {	/* in Nemacs, (b[-1] > 32) means jcode_set,
+ 				   and hence can not reduce the map */
+ 	    b += (int)b[-1] * 16;
+ 	    break;
+ 	  }
+ #endif  /* NEMACS */
  	  while ((int) b[-1] > 0 && b[b[-1] - 1] == 0)
  	    b[-1]--;
  	  b += b[-1];
***************
*** 596,601 ****
--- 702,733 ----
  	      PATPUSH (at_dot);
  	      break;
  
+ #ifdef NEMACS  /* 88.6.2, 89.9.19  by K.Handa */
+ 	    case 'c':	
+ 	      laststart = b;
+ 	      PATPUSH (categoryspec);
+ 	      PATFETCH_RAW (c);
+ 	      PATPUSH (category_spec_code[c]);
+ 	      break;
+ 
+ 	    case 'C':
+ 	      laststart = b;
+ 	      PATPUSH (notcategoryspec);
+ 	      PATFETCH_RAW (c);
+ 	      PATPUSH (category_spec_code[c]);
+ 	      break;
+ 
+ 	    case 'h':
+ 	      laststart = b;
+ 	      PATPUSH (onebyte);
+ 	      break;
+ 
+ 	    case 'z':
+ 	      laststart = b;
+ 	      PATPUSH (twobyte);
+ 	      break;
+ #endif  /* NEMACS */
+ 
  	    case 's':	
  	      laststart = b;
  	      PATPUSH (syntaxspec);
***************
*** 775,781 ****
--- 907,918 ----
  {
    unsigned char *pattern = (unsigned char *) bufp->buffer;
    int size = bufp->used;
+ #ifdef NEMACS  /* 89.9.17  by K.Handa */
+   register unsigned char *fastmap = (unsigned char *)bufp->fastmap;
+   int bf_kanji = !NULL(bf_cur->kanji_flag);
+ #else
    register char *fastmap = bufp->fastmap;
+ #endif
    register unsigned char *p = pattern;
    register unsigned char *pend = pattern + size;
    register int j, k;
***************
*** 881,886 ****
--- 1018,1030 ----
  	  break;
  
  	case wordchar:
+ #ifdef NEMACS  /* 89.9.17  by K.Handa */
+ 	  if (bf_kanji) {
+ 	    for (j = 0xa1; j < 0xff; j++)
+ 	      if (CTGJWORD(category_table[j]))
+ 		fastmap[j] = 1;
+ 	  }
+ #endif
  	  for (j = 0; j < (1 << BYTEWIDTH); j++)
  	    if (SYNTAX (j) == Sword)
  	      fastmap[j] = 1;
***************
*** 890,898 ****
--- 1034,1083 ----
  	  for (j = 0; j < (1 << BYTEWIDTH); j++)
  	    if (SYNTAX (j) != Sword)
  	      fastmap[j] = 1;
+ #ifdef NEMACS  /* 89.9.17  by K.Handa */
+ 	  if (bf_kanji) {
+ 	    for (j = 0xa1; j < 0xff; j++)
+ 	      if (CTGJWORD(category_table[j]))
+ 		fastmap[j] = 0;
+ 	    break;
+ 	  }
+ #endif
  	  break;
  
  #ifdef emacs
+ #ifdef NEMACS  /* 88.6.1  by K.Handa */
+ 	case onebyte:
+ 	  for (j = 0; j < (1 << BYTEWIDTH); j++)
+ 	    fastmap[j] = 1;
+ 	  fastmap['\n'] = 0;
+ 	  break;
+ 	  
+ 	case twobyte:
+ 	  for (j = 0xa1; j < 0xff; j++)
+ 	    fastmap[j] = 1;
+ 	  break;
+ 
+ 	case categoryspec:
+ 	  k = *p++;
+ 	  if (CTGSPECIAL(k))
+ 	    fastmap[0xa1] = 1;
+ 	  else 
+ 	    for (j = 0; j < (1 << BYTEWIDTH); j++)
+ 	      if (category_table[j] == k)
+ 		fastmap[j] = 1;
+ 	  break;
+ 
+ 	case notcategoryspec:
+ 	  k = *p++;
+ 	  if (CTGSPECIAL((enum categorycode) k)) {
+ 	    continue;
+ 	  } else
+ 	    for (j = 0; j < (1 << BYTEWIDTH); j++)
+ 	      if (category_table[j] !=  k)
+ 		fastmap[j] = 1;
+ 	  break;
+ #endif  /* NEMACS */
+ 
  	case syntaxspec:
  	  k = *p++;
  	  for (j = 0; j < (1 << BYTEWIDTH); j++)
***************
*** 909,914 ****
--- 1094,1123 ----
  #endif emacs
  
  	case charset:
+ #ifdef NEMACS  /* 89.11.14  by K.Handa */
+ 	  if (*p > 32) {
+ 	    int j;
+ 	    j = (int)*p++ * 16 - 1;
+ 	    while (j >= 16 * 0x21) {
+ 	      if (p[j]) {
+ 		if (translate)
+ 		  fastmap[translate[(j / 16) | 0x80]] = 1;
+ 		else
+ 		  fastmap[(j / 16) | 0x80] = 1;
+ 		j = j / 16 * 16;
+ 	      }
+ 	      j--;
+ 	    }
+ 	    for (j = 255; j >= 0; j--)
+ 	      if (p[j / BYTEWIDTH] & (1 << (j % BYTEWIDTH))) {
+ 		if (translate)
+ 		  fastmap[translate[j]] = 1;
+ 		else
+ 		  fastmap[j] = 1;
+ 	      }
+ 	    break;
+ 	  }
+ #endif  /* NEMACS */
  	  for (j = *p++ * BYTEWIDTH - 1; j >= 0; j--)
  	    if (p[j / BYTEWIDTH] & (1 << (j % BYTEWIDTH)))
  	      {
***************
*** 920,925 ****
--- 1129,1162 ----
  	  break;
  
  	case charset_not:
+ #ifdef NEMACS  /* 89.11.14  by K.Handa */
+ 	  if (*p > 32) {
+ 	    int j;
+ 	    j = (int)*p++ * 16 - 1;
+ 	    while (j >= 0) {
+ 	      if (p[j])	{
+ 		j = j / 16 * 16 - 1;
+ 		continue;
+ 	      }
+ 	      if (j % 16 == 0) {
+ 		if (translate)
+ 		  fastmap[translate[(j / 16) | 0x80]] = 1;
+ 		else
+ 		  fastmap[(j / 16) | 0x80] = 1;
+ 	      }
+ 	      j--;
+ 	    }
+ 	    for (j = 255; j >= 0; j--)
+ 	      if (!(p[j / BYTEWIDTH] & (1 << (j % BYTEWIDTH))))
+ 		{
+ 		  if (translate)
+ 		    fastmap[translate[j]] = 1;
+ 		  else
+ 		    fastmap[j] = 1;
+ 		}
+ 	    break;
+ 	  }
+ #endif  /* NEMACS */
  	  /* Chars beyond end of map must be allowed */
  	  for (j = *p * BYTEWIDTH; j < (1 << BYTEWIDTH); j++)
  	    if (translate)
***************
*** 975,981 ****
--- 1212,1223 ----
  int
  re_search_2 (pbufp, string1, size1, string2, size2, startpos, range, regs, mstop)
       struct re_pattern_buffer *pbufp;
+ #ifdef NEMACS  /* 88.6.9  by K.Handa */
+      unsigned char *string1, *string2;	/* We assume that the end of string1 */
+      					/* doesn't violate kanji-border. */
+ #else
       char *string1, *string2;
+ #endif
       int size1, size2;
       int startpos;
       register int range;
***************
*** 986,991 ****
--- 1228,1236 ----
    register unsigned char *translate = (unsigned char *) pbufp->translate;
    int total = size1 + size2;
    int val;
+ #ifdef NEMACS  /* 88.6.9  by K.Handa */
+   int bf_kanji = !NULL(bf_cur->kanji_flag);
+ #endif
  
    /* Update the fastmap now if not correct already */
    if (fastmap && !pbufp->fastmap_accurate)
***************
*** 1017,1022 ****
--- 1262,1270 ----
  	      register int lim = 0;
  	      register unsigned char *p;
  	      int irange = range;
+ #ifdef NEMACS  /* 88.6.9  by K.Handa */
+ 	      register int illegal_kanji_border = 0;
+ #endif
  	      if (startpos < size1 && startpos + range >= size1)
  		lim = range - (size1 - startpos);
  
***************
*** 1025,1038 ****
--- 1273,1311 ----
  
  	      if (translate)
  		{
+ #ifdef NEMACS  /* 88.1.5, 88.6.6  by K.Handa */
+ 		  while (range > lim && (!fastmap[translate[*p]]
+ 					 || bf_kanji && illegal_kanji_border))
+ 		    {
+ 		      if (*p++ & 0x80)
+ 			illegal_kanji_border = !illegal_kanji_border;
+ 		      else
+ 			illegal_kanji_border = 0;
+ 		      range--;
+ 		    }
+ #else
  		  while (range > lim && !fastmap[translate[*p++]])
  		    range--;
+ #endif
  		}
  	      else
  		{
+ #ifdef NEMACS  /* 88.1.5, 88.6.6  by K.Handa */
+ 		  while (range > lim && (!fastmap[*p]
+ 					 || bf_kanji && illegal_kanji_border))
+ 		    {
+ 		      if (*p++ & 0x80)
+ 			illegal_kanji_border = !illegal_kanji_border;
+ 		      else
+ 			illegal_kanji_border = 0;
+ 		      range--;
+ 		    }
+ 		}
+ #else
  		  while (range > lim && !fastmap[*p++])
  		    range--;
  		}
+ #endif
  	      startpos += irange - range;
  	    }
  	  else
***************
*** 1066,1072 ****
--- 1339,1360 ----
  
      advance:
        if (!range) break;
+ #ifdef NEMACS  /* 88.1.9, 88.6.6, 89.9.15  by K.Handa */
+       if (range > 0) {
+ 	if ((startpos >= size1 ? string2 - size1 : string1)[startpos] & 0x80
+ 	    && range >= 2)
+ 	  range -= 2, startpos += 2;
+ 	else
+ 	  range--, startpos++;
+       } else {
+ 	range++, startpos--;
+ 	if ((startpos >= size1 ? string2 - size1 : string1)[startpos] & 0x80
+ 	    && range <= -1)
+ 	  range++, startpos--;
+       }
+ #else
        if (range > 0) range--, startpos++; else range++, startpos--;
+ #endif
      }
    return -1;
  }
***************
*** 1122,1127 ****
--- 1410,1420 ----
    /* Pointer just past last char to consider matching */
    unsigned char *end_match_1, *end_match_2;
    register unsigned char *d, *dend;
+ #ifdef NEMACS  /* 88.1.5,  89.9.17, 89.9.19  by K.Handa */
+   int bf_kanji = !NULL(bf_cur->kanji_flag);
+   unsigned char *d_1, chr1, chr2;
+   enum categorycode ctg1, ctg2;
+ #endif
    register int mcnt;
    unsigned char *translate = (unsigned char *) pbufp->translate;
  
***************
*** 1195,1200 ****
--- 1488,1521 ----
    else
      d = string2 + pos - size1, dend = end_match_2;
  
+ #ifdef NEMACS  /* 89.9.14, 89.10.22, 90.1.25 */
+ #define D_INCRE \
+   { \
+     if (SYNTAX(*d++) == Sjapanese && bf_kanji \
+ 	&& d != dend && SYNTAX(*d) == Sjapanese) d++; \
+   }
+ #define CATEGORY_SET1 \
+   { \
+     d_1 = d - 1; \
+     chr1 = translate ? translate[*d_1] : *d_1; \
+     if (d_1 == string1 || d_1 == string2 || SYNTAX(chr1) != Sjapanese) \
+       ctg1 = (enum categorycode) SYNTAX(chr1); \
+     else { \
+       d_1--; \
+       ctg1 = CATEGORY(*d_1, chr1); \
+     } \
+   }
+ #define CATEGORY_SET2 \
+   { \
+     d_1 = (d == end1) ? string2 : d; \
+     chr1 = translate ? translate[*d_1++] : *d_1++; \
+     if (d_1 == dend || SYNTAX(chr1) != Sjapanese) \
+       ctg2 = (enum categorycode) SYNTAX(chr1); \
+     else \
+       ctg2 = CATEGORY(chr1, *d_1); \
+   }
+ #endif
+ 
  /* Write PREFETCH; just before fetching a character with *d.  */
  #define PREFETCH \
   while (d == dend)						    \
***************
*** 1306,1313 ****
--- 1627,1642 ----
  	  /* fetch a data character */
  	  PREFETCH;
  	  /* Match anything but a newline.  */
+ #ifdef NEMACS  /* 89.9.14, 89.10.20  by K.Handa */
+ 	  if ((translate ? translate[*d] : *d) == '\n') {
+ 	    d++;
+ 	    goto fail;
+ 	  }
+ 	  D_INCRE;
+ #else
  	  if ((translate ? translate[*d++] : *d++) == '\n')
  	    goto fail;
+ #endif
  	  break;
  
  	case charset:
***************
*** 1327,1332 ****
--- 1656,1674 ----
  	    else
  	      c = *d;
  
+ #ifdef NEMACS  /* 89.11.14  by K.Handa */
+ 	    if (*p > 32) {
+ 	      int cc = 0;
+ 	      if (JCODE(c)) cc = c & 0x7f, c = *(d + 1) & 0x7f;
+ 	      if (cc < *p
+ 		  && p[1 + cc * 16 + c / 8] & (1 << (c % 8)))
+ 		not = !not;
+ 	      p += 1 + (int)*p * 16;
+ 	      if (!not) goto fail;
+ 	      D_INCRE;
+ 	      break;
+ 	    }
+ #endif  /* NEMACS */
  	    if (c < *p * BYTEWIDTH
  		&& p[1 + c / BYTEWIDTH] & (1 << (c % BYTEWIDTH)))
  	      not = !not;
***************
*** 1334,1340 ****
--- 1676,1686 ----
  	    p += 1 + *p;
  
  	    if (!not) goto fail;
+ #ifdef NEMACS  /* 89.9.14, 89.10.20  by K.Handa */
+ 	    D_INCRE;
+ #else
  	    d++;
+ #endif
  	    break;
  	  }
  
***************
*** 1459,1464 ****
--- 1805,1821 ----
  	      || d == end2  /* Points to end */
  	      || (d == end1 && size2 == 0)) /* Points to end */
  	    break;
+ #ifdef NEMACS  /* 89.9.14, 89.9.20  by K.Handa */
+ 	  if (bf_kanji) {
+ 	    CATEGORY_SET1;
+ 	    CTGEXTEND(ctg1);
+ 	    CATEGORY_SET2;
+ 	    CTGEXTEND(ctg2);
+ 	    if (CTGHIRA(ctg2) && CTGJWORD(ctg1)) goto fail;
+ 	    if (ctg1 != ctg2 && (CTGWORD(ctg1) || CTGWORD(ctg2))) break;
+ 	    goto fail;
+ 	  }
+ #endif  /* NEMACS */
  	  if ((SYNTAX (d[-1]) == Sword)
  	      != (SYNTAX (d == end1 ? *string2 : *d) == Sword))
  	    break;
***************
*** 1469,1474 ****
--- 1826,1842 ----
  	      || d == end2  /* Points to end */
  	      || (d == end1 && size2 == 0)) /* Points to end */
  	    goto fail;
+ #ifdef NEMACS  /* 89.9.14, 89.9.20  by K.Handa */
+           if (bf_kanji) {
+ 	    CATEGORY_SET1;
+ 	    CTGEXTEND(ctg1);
+ 	    CATEGORY_SET2;
+ 	    CTGEXTEND(ctg2);
+ 	    if (CTGHIRA(ctg2) && CTGJWORD(ctg1)) break;
+ 	    if (ctg1 != ctg2 && (CTGWORD(ctg1) || CTGWORD(ctg2))) goto fail;
+ 	    break;
+ 	  }
+ #endif  /* NEMACS */
  	  if ((SYNTAX (d[-1]) == Sword)
  	      != (SYNTAX (d == end1 ? *string2 : *d) == Sword))
  	    goto fail;
***************
*** 1475,1480 ****
--- 1843,1862 ----
  	  break;
  
  	case wordbeg:
+ #ifdef NEMACS  /* 89.9.14  by K.Handa */
+ 	  if (bf_kanji) {
+ 	    if (d == end2 || (d == end1 && size2 == 0)) goto fail;
+ 	    CATEGORY_SET2;
+ 	    CTGEXTEND(ctg2);
+ 	    if (!CTGWORD(ctg2)) goto fail;
+ 	    if (d == string1) break;
+ 	    CATEGORY_SET1;
+ 	    CTGEXTEND(ctg1);
+ 	    if (ctg1 == ctg2
+ 		|| (CTGHIRA(ctg2) && CTGJWORD(ctg1))) goto fail;
+ 	    break;
+ 	  }
+ #endif  /* NEMACS */
  	  if (d == end2  /* Points to end */
  	      || (d == end1 && size2 == 0) /* Points to end */
  	      || SYNTAX (* (d == end1 ? string2 : d)) != Sword) /* Next char not a letter */
***************
*** 1485,1490 ****
--- 1867,1886 ----
  	  goto fail;
  
  	case wordend:
+ #ifdef NEMACS  /* 89.9.14  by K.Handa */
+ 	  if (bf_kanji) {
+ 	    if (d == string1) goto fail;
+ 	    CATEGORY_SET1;
+ 	    CTGEXTEND(ctg1);
+ 	    if (!CTGWORD(ctg1)) goto fail;
+ 	    if (d == end2 || (d == end1 && size2 == 0)) break;
+ 	    CATEGORY_SET2;
+ 	    CTGEXTEND(ctg2);
+ 	    if (ctg1 == ctg2
+ 		|| (CTGHIRA(ctg2) && CTGJWORD(ctg1))) goto fail;
+ 	    break;
+ 	  }
+ #endif  /* NEMACS */
  	  if (d == string1  /* Points to first char */
  	      || SYNTAX (d[-1]) != Sword)  /* prev char not letter */
  	    goto fail;
***************
*** 1516,1522 ****
--- 1912,1960 ----
  	    goto fail;
  	  break;
  
+ #ifdef NEMACS  /* 88.6.2, 89.9.17  by K.Handa */
+ 	case categoryspec:
+ 	  mcnt = *p++;
+ 	  CATEGORY_SET2;
+ 	  PREFETCH;
+ 	  D_INCRE;
+ 	  if (ctg2 != (enum categorycode) mcnt) goto fail;
+ 	  break;
+ 	  
+ 	case notcategoryspec:
+ 	  mcnt = *p++;
+ 	  CATEGORY_SET2;
+ 	  PREFETCH;
+ 	  D_INCRE;
+ 	  if (ctg2 == (enum categorycode) mcnt) goto fail;
+ 	  break;
+ 
+ 	case onebyte:
+ 	  PREFETCH;
+ 	  if ((translate ? translate[*d] : *d) == '\n') goto fail;
+ 	  d_1 = d;
+ 	  D_INCRE;
+ 	  if (d - d_1 == 2) goto fail;
+ 	  break;
+ 
+ 	case twobyte:
+ 	  PREFETCH;
+ 	  d_1 = d;
+ 	  D_INCRE;
+ 	  if (++d_1 == d) goto fail;
+ 	  break;
+ #endif
+ 
  	case wordchar:
+ #ifdef NEMACS  /* 89.9.17, 89.9.20  by K.Handa */
+ 	  if (bf_kanji) {
+ 	    CATEGORY_SET2;
+ 	    PREFETCH;
+ 	    D_INCRE;
+ 	    if (CTGWORD(ctg2)) break;
+ 	    goto fail;
+ 	  }
+ #endif
  	  mcnt = (int) Sword;
  	  goto matchsyntax;
  
***************
*** 1524,1533 ****
--- 1962,1987 ----
  	  mcnt = *p++;
  	matchsyntax:
  	  PREFETCH;
+ #ifdef NEMACS  /* 89.9.17, 89.9.20  by K.Handa */
+ 	  d_1 = d;
+ 	  D_INCRE;
+ 	  if (d - d_1 == 2
+ 	      || SYNTAX (*d_1) != (enum syntaxcode) mcnt) goto fail;
+ #else
  	  if (SYNTAX (*d++) != (enum syntaxcode) mcnt) goto fail;
+ #endif
  	  break;
  	  
  	case notwordchar:
+ #ifdef NEMACS  /* 89.9.17, 89.10.20  by K.Handa */
+ 	  if (bf_kanji) {
+ 	    CATEGORY_SET2;
+ 	    PREFETCH;
+ 	    D_INCRE;
+ 	    if (CTGWORD(ctg2)) goto fail;
+ 	    break;
+ 	  }
+ #endif
  	  mcnt = (int) Sword;
  	  goto matchnotsyntax;
  
***************
*** 1535,1541 ****
--- 1989,2002 ----
  	  mcnt = *p++;
  	matchnotsyntax:
  	  PREFETCH;
+ #ifdef NEMACS  /* 89.9.17, 89.9.20  by K.Handa */
+ 	  d_1 = d;
+ 	  D_INCRE;
+ 	  if (d - d_1 != 2
+ 	      && SYNTAX (*d_1) == (enum syntaxcode) mcnt) goto fail;
+ #else
  	  if (SYNTAX (*d++) == (enum syntaxcode) mcnt) goto fail;
+ #endif
  	  break;
  #else
  	case wordchar:
***************
*** 1563,1573 ****
--- 2024,2041 ----
  	  /* Match the next few pattern characters exactly.
  	     mcnt is how many characters to match. */
  	  mcnt = *p++;
+ #ifdef NEMACS	/* 89.10.22  by K.Handa */
+ 	  {  int jcnt = 0;
+ #endif
  	  if (translate)
  	    {
  	      do
  		{
  		  PREFETCH;
+ #ifdef NEMACS	/* 89.10.22  by K.Handa */
+ 		  if (SYNTAX(translate[*d]) == Sjapanese) jcnt++;
+ 		  else jcnt = 0;
+ #endif
  		  if (translate[*d++] != *p++) goto fail;
  		}
  	      while (--mcnt);
***************
*** 1577,1586 ****
--- 2045,2062 ----
  	      do
  		{
  		  PREFETCH;
+ #ifdef NEMACS	/* 89.10.22  by K.Handa */
+ 		  if (SYNTAX(*d) == Sjapanese) jcnt++;
+ 		  else jcnt = 0;
+ #endif
  		  if (*d++ != *p++) goto fail;
  		}
  	      while (--mcnt);
  	    }
+ #ifdef NEMACS	/* 89.10.22  by K.Handa */
+ 	  if (jcnt % 2 == 1 && SYNTAX(*d) == Sjapanese) goto fail;
+ 	  }
+ #endif
  	  break;
  	}
        continue;    /* Successfully matched one pattern command; keep matching */
diff -arcN emacs-18.55/src/regex.h nemacs-3.3.2/src/regex.h
*** emacs-18.55/src/regex.h	Sun Aug 14 03:15:10 1988
--- nemacs-3.3.2/src/regex.h	Wed Jun  6 03:18:22 1990
***************
*** 1,3 ****
--- 1,6 ----
+ /* 88.6.2   modified for Nemacs Ver.2.1 by K.Handa */
+ /* 89.10.19 modified for Nemacs Ver.3.2 by K.Handa */
+ 
  /* Definitions for data structures callers pass the regex library.
     Copyright (C) 1985 Free Software Foundation, Inc.
  
***************
*** 247,252 ****
--- 250,262 ----
      wordend,	 /* Succeeds if at word end */
      wordbound,   /* Succeeds if at a word boundary */
      notwordbound, /* Succeeds if not at a word boundary */
+ #ifdef NEMACS  /* 88.6.2, 89.9.19   by K.Handa */
+     categoryspec, /* Matches any character whose category is specified.
+ 		    followed by a byte which contains a wordcode, CJalpha or such like */
+     notcategoryspec, /* Matches any character whose category differs from the specified. */
+     onebyte,  /* Matches any 1-byte character */
+     twobyte,  /* Matches any 2-byte character */
+ #endif
      syntaxspec,  /* Matches any character whose syntax is specified.
  		    followed by a byte which contains a syntax code, Sword or such like */
      notsyntaxspec /* Matches any character whose syntax differs from the specified. */
diff -arcN emacs-18.55/src/search.c nemacs-3.3.2/src/search.c
*** emacs-18.55/src/search.c	Thu Aug  3 15:05:06 1989
--- nemacs-3.3.2/src/search.c	Wed Jun  6 03:18:22 1990
***************
*** 1,3 ****
--- 1,7 ----
+ /* 88.1.7   modified for Nemacs Ver.2.0 by K.Handa */
+ /* 90.2.27  modified for Nemacs Ver.3.3 by K.Handa
+ 	Fouth argument of search_buffer is corrected. */
+ 
  /* String search routines for GNU Emacs.
     Copyright (C) 1985, 1986, 1987 Free Software Foundation, Inc.
  
***************
*** 25,30 ****
--- 29,37 ----
  #include "buffer.h"
  #include "commands.h"
  #include "regex.h"
+ #ifdef NEMACS  /* 89.9.13  by K.Handa */
+ #include "kanji.h"
+ #endif
  
  #define max(a, b) ((a) > (b) ? (a) : (b))
  #define min(a, b) ((a) < (b) ? (a) : (b))
***************
*** 360,366 ****
    if (forwardp)
      {
        while (point < XINT (lim) && fastmap[CharAt (point)])
! 	PointRight (1);
      }
    else
      {
--- 367,377 ----
    if (forwardp)
      {
        while (point < XINT (lim) && fastmap[CharAt (point)])
! #ifdef NEMACS  /* 89.9.13  by K.Handa */
! 	PointRight (((EUC_P(CharAt (point))) ? 2 : 1));
! #else
!         PointRight (1);
! #endif
      }
    else
      {
***************
*** 386,391 ****
--- 397,405 ----
      {
        CHECK_NUMBER (count, 3);
        n *= XINT (count);
+ #ifdef NEMACS  /* 90.2.27  by K.Handa & enami@ptgd.sony.co.jp */
+       direction = n > 0 ? 1 : -1;
+ #endif
      }
  
    CHECK_STRING (string, 0);
***************
*** 403,410 ****
--- 417,444 ----
  	lim = FirstCharacter;
      }
  
+ #ifdef NEMACS  /* 88.5.30  by K.Handa */
+   if (NULL(bf_cur->kanji_flag) || RE)
+ #endif
    np = search_buffer (string, point, lim, n, RE,
  		      !NULL (bf_cur->case_fold_search) ? downcase_table : 0);
+ #ifdef NEMACS  /* 88.5.30, 89.8.24  by K.Handa */
+   else {
+     np = point;
+     while (FirstCharacter <= np && np <= NumCharacters + 1 && n != 0) {
+       np = search_buffer (string, np, lim, direction, RE,
+ 		      !NULL (bf_cur->case_fold_search) ? downcase_table : 0);
+       if (n > 0) {
+ 	if (kanji_point(np - XSTRING(string)->size) < 2) n--;
+ 	else np -= XSTRING(string)->size - 1;
+       } else {
+ 	if (kanji_point(np) < 2) n++;
+       }
+     }
+   }
+   if (kanji_point(np) == 2) np += direction;
+ #endif  /* NEMACS */
+ 
    if (np <= 0)
      {
        if (NULL (noerror))
